<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="mhp.oee.dao.extend.ReasonCodeAlertAndResourceTypeAndReasonCodePOMpper">
  <resultMap id="BaseResultMap" type="mhp.oee.po.extend.ReasonCodeAlertAndResourceTypeAndReasonCodePO">
    <id column="HANDLE" jdbcType="VARCHAR" property="handle" />
    <result column="RESOURCE_TYPE_BO" jdbcType="VARCHAR" property="resourceTypeBo" />
    <result column="ALERT_SEQUENCE_ID" jdbcType="VARCHAR" property="alertSequenceId" />
    <result column="REASON_CODE_BO" jdbcType="VARCHAR" property="reasonCodeBo" />
    <result column="STRT" jdbcType="VARCHAR" property="strt" />
    <result column="DESCRIPTION" jdbcType="VARCHAR" property="description" />
    <result column="USED" jdbcType="VARCHAR" property="used" />
    <result column="START_DATE_TIME" jdbcType="TIMESTAMP" property="startDateTime" />
    <result column="END_DATE_TIME" jdbcType="TIMESTAMP" property="endDateTime" />
    <result column="CREATED_DATE_TIME" jdbcType="TIMESTAMP" property="createdDateTime" />
    <result column="MODIFIED_DATE_TIME" jdbcType="TIMESTAMP" property="modifiedDateTime" />
    <result column="MODIFIED_USER" jdbcType="VARCHAR" property="modifiedUser" />
    <association property="resourceTypePO" column="handle" javaType="mhp.oee.po.gen.ResourceTypePO">
        <id column="HANDLE" jdbcType="VARCHAR" property="handle" />
	    <result column="SITE" jdbcType="VARCHAR" property="site" />
	    <result column="RESOURCE_TYPE" jdbcType="VARCHAR" property="resourceType" />
	    <result column="ENABLED" jdbcType="VARCHAR" property="enabled" />
	    <result column="RESOURCE_TYPE_DES" jdbcType="VARCHAR" property="description" />
	    <result column="CREATED_DATE_TIME" jdbcType="TIMESTAMP" property="createdDateTime" />
	    <result column="MODIFIED_DATE_TIME" jdbcType="TIMESTAMP" property="modifiedDateTime" />
	    <result column="MODIFIED_USER" jdbcType="VARCHAR" property="modifiedUser" />
    </association> 
    <association property="reasonCodePO" column="handle" javaType="mhp.oee.po.gen.ReasonCodePO">
        <id column="HANDLE" jdbcType="VARCHAR" property="handle" />
	    <result column="SITE" jdbcType="VARCHAR" property="site" />
	    <result column="REASON_CODE" jdbcType="VARCHAR" property="reasonCode" />
	    <result column="REASON_CODE_DES" jdbcType="VARCHAR" property="description" />
	    <result column="REASON_CODE_GROUP" jdbcType="VARCHAR" property="reasonCodeGroup" />
	    <result column="ENABLED" jdbcType="VARCHAR" property="enabled" />
	    <result column="CREATED_DATE_TIME" jdbcType="TIMESTAMP" property="createdDateTime" />
	    <result column="MODIFIED_DATE_TIME" jdbcType="TIMESTAMP" property="modifiedDateTime" />
	    <result column="MODIFIED_USER" jdbcType="VARCHAR" property="modifiedUser" />
    </association>
  </resultMap>
  <select id="selectReasonCodeAlertCurentPage" resultMap="BaseResultMap">
	SELECT A.*, B.REASON_CODE, B.DESCRIPTION AS REASON_CODE_DES, C.RESOURCE_TYPE, C.DESCRIPTION AS RESOURCE_TYPE_DES FROM REASON_CODE_ALERT AS A INNER JOIN REASON_CODE AS B ON
	A.REASON_CODE_BO = B.HANDLE
	INNER JOIN RESOURCE_TYPE AS C
	ON A.RESOURCE_TYPE_BO = C.HANDLE
	WHERE C.SITE = #{site}
	AND C.RESOURCE_TYPE IN
	<foreach close=')' collection='resourceTypes' item='resourceType' open='(' separator=','>
		#{resourceType}
	</foreach>
	AND A.START_DATE_TIME &lt;= #{time}
	AND A.END_DATE_TIME &gt; #{time}
	ORDER BY A.RESOURCE_TYPE_BO, A.ALERT_SEQUENCE_ID, A.START_DATE_TIME
	<if test="limit != null">
		<if test="offset != null">
			limit ${limit} offset ${offset}
		</if>
		<if test="offset == null">
			limit ${limit}
		</if>
	</if>
</select>
	<select id="selectReasonCodeAlertCurentPageCount" resultType="java.lang.Integer">
		SELECT COUNT(*) FROM REASON_CODE_ALERT AS A INNER JOIN REASON_CODE AS B ON
		A.REASON_CODE_BO = B.HANDLE
		INNER JOIN RESOURCE_TYPE AS C
		ON A.RESOURCE_TYPE_BO = C.HANDLE
		WHERE C.SITE = #{site}
		AND C.RESOURCE_TYPE IN
		<foreach close=')' collection='resourceTypes' item='resourceType' open='(' separator=','>
			#{resourceType}
		</foreach>
		AND A.START_DATE_TIME &lt;= #{time}
		AND A.END_DATE_TIME &gt; #{time}
	</select>

	<select id="selectReasonCodeAlertHisChange" resultMap="BaseResultMap">
		SELECT A.*, B.REASON_CODE, B.DESCRIPTION AS REASON_CODE_DES, C.RESOURCE_TYPE, C.DESCRIPTION AS RESOURCE_TYPE_DES FROM REASON_CODE_ALERT AS A INNER JOIN REASON_CODE AS B ON
		A.REASON_CODE_BO = B.HANDLE
		INNER JOIN RESOURCE_TYPE AS C
		ON A.RESOURCE_TYPE_BO = C.HANDLE
		WHERE C.SITE = #{site}
		AND C.RESOURCE_TYPE IN
		<foreach close=')' collection='resourceTypes' item='resourceType' open='(' separator=','>
			#{resourceType}
		</foreach>
		AND CAST(A.START_DATE_TIME AS DATE) &gt;= CAST(#{time} AS DATE)
		ORDER BY A.RESOURCE_TYPE_BO, A.ALERT_SEQUENCE_ID, A.START_DATE_TIME
		<if test="limit != null">
			<if test="offset != null">
				limit ${limit} offset ${offset}
			</if>
			<if test="offset == null">
				limit ${limit}
			</if>
		</if>
	</select>
	<select id="selectReasonCodeAlertHisChangeCount" resultType="java.lang.Integer">
		SELECT COUNT(*) FROM REASON_CODE_ALERT AS A INNER JOIN REASON_CODE AS B ON
		A.REASON_CODE_BO = B.HANDLE
		INNER JOIN RESOURCE_TYPE AS C
		ON A.RESOURCE_TYPE_BO = C.HANDLE
		WHERE C.SITE = #{site}
		AND C.RESOURCE_TYPE IN
		<foreach close=')' collection='resourceTypes' item='resourceType' open='(' separator=','>
			#{resourceType}
		</foreach>
		AND CAST(A.START_DATE_TIME AS DATE) &gt;= CAST(#{time} AS DATE)
	</select>

	<select id="selectReasonCodeAlertHisStatus" resultMap="BaseResultMap">
		SELECT A.*, B.REASON_CODE, B.DESCRIPTION AS REASON_CODE_DES, C.RESOURCE_TYPE, C.DESCRIPTION AS RESOURCE_TYPE_DES FROM REASON_CODE_ALERT AS A INNER JOIN REASON_CODE AS B ON
		A.REASON_CODE_BO = B.HANDLE
		INNER JOIN RESOURCE_TYPE AS C
		ON A.RESOURCE_TYPE_BO = C.HANDLE
		WHERE C.SITE = #{site}
		AND C.RESOURCE_TYPE IN
		<foreach close=')' collection='resourceTypes' item='resourceType' open='(' separator=','>
			#{resourceType}
		</foreach>
		AND CAST(A.START_DATE_TIME AS DATE) &lt;= CAST(#{time} AS DATE)
		AND CAST(A.END_DATE_TIME AS DATE) &gt;= CAST(#{time} AS DATE)
		ORDER BY A.RESOURCE_TYPE_BO, A.ALERT_SEQUENCE_ID, A.START_DATE_TIME
		<if test="limit != null">
			<if test="offset != null">
				limit ${limit} offset ${offset}
			</if>
			<if test="offset == null">
				limit ${limit}
			</if>
		</if>
	</select>
	<select id="selectReasonCodeAlertHisStatusCount" resultType="java.lang.Integer">
		SELECT COUNT(*) FROM REASON_CODE_ALERT AS A INNER JOIN REASON_CODE AS B ON
		A.REASON_CODE_BO = B.HANDLE
		INNER JOIN RESOURCE_TYPE AS C
		ON A.RESOURCE_TYPE_BO = C.HANDLE
		WHERE C.SITE = #{site}
		AND C.RESOURCE_TYPE IN
		<foreach close=')' collection='resourceTypes' item='resourceType' open='(' separator=','>
			#{resourceType}
		</foreach>
		AND CAST(A.START_DATE_TIME AS DATE) &lt;= CAST(#{time} AS DATE)
		AND CAST(A.END_DATE_TIME AS DATE) &gt;= CAST(#{time} AS DATE)
	</select>
</mapper>